VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form FrmWord 
   Caption         =   "Form1"
   ClientHeight    =   6150
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6270
   LinkTopic       =   "Form1"
   ScaleHeight     =   6150
   ScaleWidth      =   6270
   StartUpPosition =   3  'Windows Default
   Begin RichTextLib.RichTextBox RtfDoc 
      Height          =   2595
      Left            =   0
      TabIndex        =   3
      Top             =   3540
      Width           =   6255
      _ExtentX        =   11033
      _ExtentY        =   4577
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"FrmWord.frx":0000
   End
   Begin VB.FileListBox File1 
      Height          =   3210
      Left            =   3180
      TabIndex        =   2
      Top             =   0
      Width           =   3015
   End
   Begin VB.DirListBox Dir1 
      Height          =   2790
      Left            =   0
      TabIndex        =   1
      Top             =   420
      Width           =   3135
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   10
      Width           =   3135
   End
   Begin VB.Label LblWarning 
      AutoSize        =   -1  'True
      Caption         =   "No more than 64k in RichtextBox in a single step!"
      ForeColor       =   &H000000FF&
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   3300
      Width           =   3480
   End
End
Attribute VB_Name = "FrmWord"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'referenced microsoft word 9.0 object library
'that is : word 2000
Private wdApp As Word.Application

Private Sub Form_Load()
    File1.Pattern = "*.doc"
    Me.Caption = "Doubleclick on a doc to read it"
End Sub

Private Sub Dir1_Change()
    File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()
    On Error GoTo errHandler
    Dir1.Path = Drive1.Drive
    Exit Sub
errHandler:
    Drive1.Drive = Environ$("SystemDrive")
End Sub


Private Sub File1_DblClick()
    Dim sFileNamePath As String
    Dim sText As String
    
    'path and name
    sFileNamePath = AddSlash(File1.Path) & File1.FileName
    
    'instantiate word
    If wdApp Is Nothing Then
        Set wdApp = New Word.Application
     End If
     'get the doc
     Dim wdDoc As Word.Document
     
     Set wdDoc = wdApp.Documents.Open(sFileNamePath)
     'convert to plain text
     wdDoc.SaveAs sFileNamePath & ".txt", FileFormat:=wdFormatText
     'close word
     wdDoc.Close SaveChanges:=wdDoNotSaveChanges
     Set wdDoc = Nothing
     wdApp.Quit
     'Open plain text file
     sText = getStringContentAtOnce(sFileNamePath & ".txt")
     'now, if content is not too big, load it in richtext
     If FileLen(sFileNamePath & ".txt") < 64000 Then
        RtfDoc.FileName = sFileNamePath & ".txt"
     Else
        RtfDoc.Text = "File is too big to load here, but look at " & sFileNamePath & ".txt"
     End If
     'here in any case you have the content of file in sText variable...
End Sub

Private Function AddSlash(ByVal sPath As String) As String
    sPath = Trim(sPath)
    If Len(sPath) > 0 Then
        If Right$(sPath, 1) <> "/" Then
            If Right$(sPath, 1) <> "\" Then
                sPath = sPath & "\"
            End If
        End If
        AddSlash = sPath
    End If
End Function

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set wdApp = Nothing
End Sub

Private Function getStringContentAtOnce(ByVal FileName As String) As String

    Dim intFree As Integer
     
    ' ensure that the file exists
    If Len(Dir$(FileName)) = 0 Then
        Err.Raise 53  ' File not found
    End If
     
    ' open in binary mode
    intFree = FreeFile
    Open FileName$ For Binary As #intFree
    ' read the string and close the file
    getStringContentAtOnce = Space$(LOF(intFree))
    Get #intFree, , getStringContentAtOnce
    Close #intFree
End Function
